
package snaptaxi;

import java.net.InetAddress;

/**
 * Network Address.
 * This can be used key value.
 * 
 * @author Korea Univ. SE Team #1
 * @version 1.0
 * @since 2004.11.14
 * [2004.11.14.] ~ Add source.
 * [2004.11.19.] ~ Change port type from short to int. 
 * [2004.11.19.] ~ Update Document.
 * [2004.11.19.] ~ override hashCode(), equals() method for key.
 */
 
public class Address 
{

	// port
	private int port;

	// ip
	private InetAddress ip;

	/**
	 * Build null address.
	 */
	public Address()
	{
		port = 0;
	    ip = null;
	}
	
	/**
	 * Build address.
	 * This is unique way for setting property.
	 * You cannot change these value anymore.
	 * 
	 * @param ip
	 * @param port
	 */
	public Address(InetAddress ip, int port) 
	{
	    this.ip = ip;
	    this.port = port;
	}
	
	/**
	 * Get IP address.
	 * 
	 * @return java.net.InetAddress
	 */
	public InetAddress getIP() 
	{
		return ip;
	}
	
	/**
	 * Get Port number.
	 * 
	 * @return short
	 */
	public int getPort() 
	{
		return port;
	}

	public int hashCode()
	{
		return this.ip.hashCode() + port;
	}
	
	public boolean equals(Object obj)
	{
		return (this.hashCode() == ((Address) obj).hashCode());
	}
}