
package snaptaxi;

import java.util.*;

/**
 * This is status of passenger request.
 * When passenger call taxi. System create this status.
 * @author Korea Univ. SE Team #1
 * @version 1.0
 * @since 2004.11.14
 * [2004.11.14.] ~ Add source.
 * [2004.11.14.ȫ/] ~ setState.
 * [2004.11.20.] - add constant state. update document.
 *						state	STATE_ERROR			: error state(initial value)
 *					 			STATE_REQUEST		: call request (when call)
 * 								STATE_ANSWER		: call answer (when select)
 * 								STATE_HANDLING_END	: call handling end(handle in taxi)
 * [2004.11.20.] - Change "HashSet taxiSet" to "LinkedList taxiList"
 */
public class CallState 
{
	// error state. (initial value)
	final public static int STATE_ERROR = 0;

	// call request (when call)
	final public static int STATE_REQUEST = 1;

	// call answer (when select)
	final public static int STATE_ANSWER = 2;

	// call handling end (handle in taxi)
	final public static int STATE_HANDLING_END = 3;

	public CallState() 
	{
		state = STATE_ERROR;
	}
	
	/**
	 * change taxi list which is sent by call.
	 * @param taxiList - (its type is CustomerState)
	 */
	public void setTaxiList(LinkedList taxiList) 
	{
		this.taxiList = taxiList;
	}
	
	/**
	 * get current taxi list which is sent by call.
	 * @return - taxi list (its type is CustomerState)
	 */
	public LinkedList getTaxiList() 
	{
		return taxiList;
	}
	
	/**
	 * @param - state	STATE_ERROR
	 * 					STATE_REQUEST
	 * 					STATE_ANSWER
	 * 					STATE_HANDLING_END
	 */
	public void setState(int state) 
	{
		this.state = state;
	}

	/**
	 * @return - state	STATE_ERROR
	 * 					STATE_REQUEST
	 * 					STATE_ANSWER
	 * 					STATE_HANDLING_END
	 */
	public int getState() 
	{
		return state;
	}

	// Set of customerState who is taxi.
	private LinkedList taxiList;

	// state	STATE_ERROR			: error state(initial value)
	// 			STATE_REQUEST		: call request (when call)
	// 			STATE_ANSWER		: call answer (when select)
	// 			STATE_HANDLING_END	: call handling end(handle in taxi)
	private int state;
}
