
package snaptaxi;


/**
 * @author Korea Univ. SE Team #1
 * @version 1.0
 * @since 2004.11.14
 * [2004.11.14.] ~ Add source.
 * [2004.11.14.] ~ source modification for DB.java
 * [2004.11.15.] ~ Comment addtion
 * [2004.11.15.] ~ property modification with private in public 
 * [2004.11.20.] - Add constant.
 */
public class CustomerData 
{
	/**
	 * Kinds of customer.
	 * CUSTOMER_ERROR - error.
	 * CUSTOMER_PASSENGER - passenger.
	 * CUSTOMER_TAXI - taxi.
	 */
    private byte type;

    // error
    final public static byte CUSTOMER_ERROR = 0;
    
    // passenger.
    final public static byte CUSTOMER_PASSENGER = 1;
    
    // taxi.
    final public static byte CUSTOMER_TAXI = 2;
	
	// customer id
    private String id;
	
	// customer password.
    private String pass;
	
	public CustomerData() 
	{
		type = 0;
		id = "";
		pass = "";
	}
	
	public CustomerData(String id, String pass, byte type)
	{
	    this.id = id;
	    this.pass = pass;
	    this.type = type;
	}

	/**
	 * Change id
	 * @param id - new id.
	 */
	public void setID(String id)
	{
	    this.id = id;
	}

	/**
	 * Get ID
	 * @return - current id.
	 */
	public String getID()
	{
	    return this.id;
	}

	/**
	 * Change password.
	 * @param pass - new password.
	 */
	public void setPass(String pass)
	{
	    this.pass = pass;
	}

	/**
	 * Get password.
	 * @return - current password.
	 */
	public String getPass()
	{
	    return this.pass;
	}

	/**
	 * change customer type.
	 * @param type
	 * CUSTOMER_ERROR - error.
	 * CUSTOMER_PASSENGER - passenger.
	 * CUSTOMER_TAXI - taxi.
	 */
	public void setType(byte type)
	{
	    this.type = type;
	}

	/**
	 * check customer type.
	 * @return
	 * CUSTOMER_ERROR - error.
	 * CUSTOMER_PASSENGER - passenger.
	 * CUSTOMER_TAXI - taxi.
	 */
	public byte getType()
	{
	    return this.type;
	}
}
