
package snaptaxi;

import java.util.*;

/**
 * @author Korea Univ. SE Team #1
 * @version 1.0
 * @since 2004.11.14
 * [2004.11.14.] ~ Add source.
 * [2004.11.14.ȫ/] - implement.
 * [2004.11.20.] - remove idList.
 * [2004.11.20.] - update find() method.
 */
public class CustomerMgr 
{
	// Map<String customerID, CustomerState customerState>
	private HashMap stateMap;

	public CustomerMgr() 
	{
		stateMap = new HashMap();
	}

	/**
	 * Put new customer to stateMap.
	 * @param id - customer id who is login.
	 */
	public void login(String id) 
	{
		stateMap.put(id, new CustomerState());
	}

	/**
	 * Delete customer from stateMap.
	 * @param id - customer id who is logout.
	 */
	public void logout(String id) 
	{
		stateMap.remove(id);
	}
	
	/**
	 * search customer list by postion and radius.
	 * @param posX - center x
	 * @param posY - center y
	 * @param radius - radius
	 * @return LinkedList - result CustomerState list.
	 */
	public LinkedList find(int posX, int posY, int radius)
	{
		LinkedList result = new LinkedList();

		int r2 = radius * radius;

		Iterator iter = this.stateMap.values().iterator();
		while(iter.hasNext()) {
			CustomerState cs = (CustomerState) iter.next();
			if (cs.getState() == CustomerState.STATE_READY) {
				int lx = cs.getPosX() - posX;
				lx *= lx;
				int ly = cs.getPosY() - posY;
				ly *= ly;
				if (r2 >= lx + ly) {
					// taxi is in range.
					// Add object to result list.
					result.add(cs);
				}
			}
		}
		return result;
	}

	/**
	 * If received id is logging, return true.
	 * @param id
	 * @return bool
	 */
	public boolean isLogin(String id)
	{
		return stateMap.containsKey(id);		
	}

	/**
	 * Return state of customer.
	 * @param id
	 * @return snaptaxi.CustomerState
	 */
	public CustomerState getState(String id) 
	{
		return (CustomerState)(stateMap.get(id));
	}
}