
package snaptaxi;

import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.Connection;
import java.util.Hashtable;
/**
 * @author Korea Univ. SE Team #1
 * @version 1.0
 * @since 2004.11.14
 * [2004.11.14.] ~ Add source.
 * [2004.11.14.] ~ Edited
 * [2004.11.14.] ~ delete unnecessary comment 
 * [2004.11.14.] ~ import java.sql.Connection addition.
 * [2004.11.15.] ~ source modification according to CustomerState change
 * [2004.11.28.] ~ Handling Exception to take a hashtable in DB.
 */
public class DB 
{
	private Connection conn = null;
	private Hashtable tempStorage = new Hashtable();
	
	public DB() 
	{

        try { 
            // Declare Myconnector/J to connect DB
        	// com.mysql.jdbc.Driver is not called in import 
        	// as follows  com.mysql.jdbc.Driver was used in newInstance

            Class.forName("com.mysql.jdbc.Driver").newInstance(); 
        } catch (Exception ex) { 
        	// Exception handling  : if exception, retuen 0 and terminate thread 
         	System.out.println("SQLException1: " + ex.getMessage()); 
         	//return null;
        }
        try {
        	//  Way which connected to DB
        	// when connect to DB, use a connect way DB of JDBC driver  
        	// "jdbc:mysql://<ip ̸>/<db ̸>?user=<DB_̵>&password=<DB н>"
        	
            conn = DriverManager.getConnection("jdbc:mysql://exunar.w3ip.com/user_se?user=seuser&password=se2004");

            
        } catch (SQLException ex) {
        	// Exception handling  : if exception, return 0 and terminate thread 
            System.out.println("SQLException2: " + ex.getMessage()); 
            //return null;
        }		
	}
	
	/**
	 * @param id
	 * @return bool
	 */
	public boolean isExist(String id) 
	{
		Statement stmt = null; 
        ResultSet rs = null;
        
        try {
        	// Way which send Query to DB
         	//When send a Query, if return answer, use a executeQuery 
         	// except for this case, use a execute 
  
	       	stmt = conn.createStatement();
	       	
			rs = stmt.executeQuery("SELECT id,passwd FROM `login` WHERE id='"+id+"';");
        	
        	while(rs.next()) {
        		if(id.equals(rs.getString("id"))) {
        			// DB connection is unnecessary so , close  Statement type and ResultSet type at the end
           			if (rs != null) { 
                		try {
                			rs.close(); 
                		} catch (SQLException sqlEx) { // ignore }
                			if(tempStorage.get(id) != null) return true;
                        	else return false;
                			//System.out.println("SQLException2: " + sqlEx.getMessage()); 
                			//rs = null; 
                		}
                	}
                	if (stmt != null) { 
                		try { 
                			stmt.close(); 
                		} catch (SQLException sqlEx) { // ignore } 
                			if(tempStorage.get(id) != null) return true;
                        	else return false;
                			//System.out.println("SQLException2: " + sqlEx.getMessage()); 
                			//stmt = null; 
                		} 
                
                	}
                	return true;
        		}
        	}
        			
        			
	     	       	 
        	
         } catch (SQLException e) {
        	// Exception handling.
        	// Auto generated code for error preventation for Eclipse
        	// TODO : ̰  ʿ ˾ƺ  .
        	if(tempStorage.get(id) != null) return true;
        	else return false;
        	//System.out.println("SQLException3: " + e.getMessage());
			//e.printStackTrace();
			//return null;
		} finally {

		}
		return false;		
	}
	
	/**
	 * @param unregistMsg
	 */
	public void unregist(UnregistMsg unregistMsg) 
	{
		
	}
	
	/**
	 * @param form
	 * @param registMsg
	 * @return bool
	 */
	public boolean regist(RegistMsg registMsg) 
	{
		if(isExist(registMsg.getID()))
		{
			return false;
		} else {
			Statement stmt = null; 
	        boolean result = false;
	        
	        try {
	        	// Way which send a query to DB 
	         	// When send a Query, if return answer, use a executeQuery   
	         	// except for this case, use a execute 
	  
		       	stmt = conn.createStatement();
		       	
				result = stmt.execute("INSERT INTO `login`(`id`,`passwd`,`type`) VALUES ('"+registMsg.getID()+"',PASSWORD('"+registMsg.getPass()+"'),'"+registMsg.getType());
	        	return result;
	         } catch (SQLException e) {
	        	// Exception handling.
	        	// Auto generated code for error preventation for Eclipse
	        	// TODO : ̰  ʿ ˾ƺ  .
	        	if(tempStorage.put(registMsg.getID(),registMsg) != null) return true;
	        	else return false;
	        	//System.out.println("SQLException3: " + e.getMessage());
				//e.printStackTrace();
				//return null;
			} finally {
	
			}
			//return result;
		//return true;
		}		
	}
	
	/**
	 * @param id
	 * @return snaptaxi.CustomerData
	 */
	public CustomerData findCustomerData(String id) 
	{
		CustomerData tempCustomerData = new CustomerData(); 
		Statement stmt = null; 
        ResultSet rs = null;
        
        try {
        	// Way which send Query to DB
         	// when send a Query, in case return answer use a executeQuery 
         	// except for this case,  use execute 
  
	       	stmt = conn.createStatement();
	       	
			rs = stmt.executeQuery("SELECT id,passwd FROM `login` WHERE id='"+id+"';");
        	
        	while(rs.next()) {
        		if(id.equals(rs.getString("id"))) {
        			
        			tempCustomerData.setID(id);
        			tempCustomerData.setPass(rs.getString("passwd"));
        			tempCustomerData.setType(rs.getByte("type"));
        			// DB connection is unnecessary so , close  Statement type and ResultSet type at the end
                	
        			if (rs != null) { 
                		try {
                			rs.close(); 
                		} catch (SQLException sqlEx) { // ignore }
                			RegistMsg temp = (RegistMsg) tempStorage.get(id);
                         	tempCustomerData.setID(id);
                			tempCustomerData.setPass(temp.getPass());
                			tempCustomerData.setType(temp.getType());
                			return tempCustomerData;
                			//System.out.println("SQLException2: " + sqlEx.getMessage()); 
                			//rs = null; 
                		}
                	}
                	if (stmt != null) { 
                		try { 
                			stmt.close(); 
                		} catch (SQLException sqlEx) { // ignore } 
                			
                			RegistMsg temp = (RegistMsg) tempStorage.get(id);
                         	tempCustomerData.setID(id);
                			tempCustomerData.setPass(temp.getPass());
                			tempCustomerData.setType(temp.getType());
                			return tempCustomerData;
                			//System.out.println("SQLException2: " + sqlEx.getMessage()); 
                			//stmt = null; 
                		} 
                
                	}
                	return tempCustomerData;
        			
        		}
        	}
	     	       	 
        	
         } catch (SQLException e) {
        	// Exception handling.
        	// Auto generated code for error prevention of Eclipse
        	// TODO : ̰  ʿ ˾ƺ  .
         	RegistMsg temp = (RegistMsg) tempStorage.get(id);
         	tempCustomerData.setID(id);
			tempCustomerData.setPass(temp.getPass());
			tempCustomerData.setType(temp.getType());
			return tempCustomerData;
        	//System.out.println("SQLException3: " + e.getMessage());
			//e.printStackTrace();
			//return null;
		} finally {

		}
		
		return null;		
	}
}