
package snaptaxi;


/**
 * @author Korea Univ. SE Team #1
 * @version 1.0
 * @since 2004.11.14
 * [2004.11.14.] ~ Add source.
 * [2004.11.15.] ~ Add msg inheritance.
 * [2004.11.20.] - Add type constant.
 */
public class RegistMsg extends Message 
{
	/**
	 * customer type.
	 * CUSTOMER_ERROR - initial state.
	 * CUSTOMER_PASSENGER - passenger.
	 * CUSTOMER_TAXI - taxi.
	 */
	private byte type;

	// initial state
	final public byte CUSTOMER_ERROR = 0;
	
	// customer is passenger.
	final public byte CUSTOMER_PASSENGER = 1;
	
	// customer is taxi.
	final public byte CUSTOMER_TAXI = 2;

	// customer id
	private String id;
	
	// customer pass
	private String pass;
	
	public RegistMsg() 
	{
		type = 0;
		id = "";
		pass = 	"";		
	}
	
	/**
	 * @param id ~id
	 * @param pass ~password
	 * @param type ~type
	 */
	public RegistMsg(String id, String pass, byte type) 
	{
		this.id = id;
		this.pass = pass;
		this.type = type;		
	}
	
	/**
	 * Check customer id.
	 * @return String - cutomer id
	 */
	public String getID() 
	{
		return id;		
	}
	
	/**
	 * Check customer password.
	 * @return String - customer password for regist.
	 */
	public String getPass() 
	{
		return pass;		
	}
	
	/**
	 * Check customer type.
	 * @return byte - customer type. (passenger or taxi)
	 */
	public byte getType() 
	{
		return type;		
	}
}
