
package snaptaxi;

/**
 * @author Korea Univ. SE Team #1
 * @version 1.0
 * @since 2004.11.14
 * [2004.11.21.] ~ Add source.
 * [2004.11.21.] - Initial code.
 * [2004.11.21.] - Add DB Error code.
 * [2004.11.29./] ~ Add isSucessed / isRegistered.
 */
public class RegistResultMsg extends Message {
	
	/**
	 * REGIST result state flag
	 * REGIST_ERROR				: error
	 * REGIST_SUCCESS			: regist succession
	 * REGIST_REGISTERED		: already registered customer
	 * REGIST_DBERROR			: database error.
	 */
	private int registCode;

	// error
	final static public int REGIST_ERROR = 0;

	// regist succession
	final static public int REGIST_SUCCESS = 1;
	
	// already registered customer
	final static public int REGIST_REGISTERED = 2;
	
	final static public int REGIST_DBERROR = 3;
	
	/**
	 * @param registCode
	 * REGIST_ERROR				: error
	 * REGIST_SUCCESS			: regist succession
	 * REGIST_REGISTERED		: already registered customer
	 * REGIST_DBERROR			: database error.
	 */
	public RegistResultMsg(int registCode) 
	{
		this.registCode = registCode;
	}
	
	public RegistResultMsg() 
	{
		this.registCode = REGIST_ERROR;
	}
	
	public int getRegistCode()
	{
		return this.registCode;
	}
	
	public boolean isSuccess() 
	{
		return (this.registCode == REGIST_SUCCESS);
	}
	
	public boolean isRegistered() 
	{
		return (this.registCode == REGIST_REGISTERED);	
	}
}
