
package snaptaxi;

/**
 * Unselect message.
 * @author Korea Univ. SE Team #1
 * @version 1.0
 * @since 2004.11.14
 * [2004.11.14.] ~ Add source.
 * [2004.11.15.] ~ Add msg inheritance.
 * [2004.11.20.] - Update Document.
 */
public class UnselectMsg extends Message
{
	private String taxiID;
	private String passengerID;

	public UnselectMsg() 
	{
		this.taxiID = "";
		this.passengerID = "";
	}
	
	/**
	 * Set unselect data.
	 * @param taxiID - taxi who unselect passenger.
	 * @param passengerID - passenger who is unselected by taxi.
	 */
	public UnselectMsg(String taxiID, String passengerID) 
	{
		this.taxiID = taxiID;
		this.passengerID = passengerID;
	}
	
	/**
	 * Get taxi who unselect passenger.
	 * @return String - taxi ID.
	 */
	public String getTaxiID() 
	{
		return this.taxiID;
	}

	/**
	 * Get Passenger who is unselected by taxi.
	 * @return String - passenger ID.
	 */
	public String getPassengerID() 
	{
		return this.passengerID;
	}
}
