
package snaptaxi.passenger;

import javax.swing.WindowConstants;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JLabel;
import java.awt.event.MouseEvent;
import java.awt.event.MouseAdapter;

import javax.swing.JDesktopPane;
import java.awt.BorderLayout;


/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* *************************************
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED
* for this machine, so Jigloo or this code cannot be used legally
* for any corporate or commercial purpose.
* *************************************
*/
import javax.swing.SwingConstants;
/**
 * @author Korea Univ. SE Team #1
 * @version 1.0
 * @since 2004.11.20
 * [2004.11.20./] ~ Add source.
 * [2004.11.20./] ~ Add code, Add comment.
 * [2004.11.29.] ~ Add code in Login Button.
 * [2004.11.29.] ~ Add code in Join Button, Add Register method from Register.java
 * [2004.11.29.] ~ Change static jlabel4 to access from PassengerListener.
 * [2004.11.29.] ~ move main method to PassengerClient.java.
 */
public class Login extends javax.swing.JFrame
{
	private JDesktopPane jDesktopPane1;
	private JButton jButton1;
	private JLabel jLabel2;
	private JButton jButton2;
	public JLabel jLabel4;
	private JLabel jLabel3;
	private JLabel jLabel1;
	private JTextField jTextField1;
	private JPasswordField jPasswordField1;

	{
		//Set Look & Feel
		try {
			javax.swing.UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
		} catch(Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Return jLabel for display information.
	 */
	public JLabel getJLabel4()
	{
		return jLabel4;
	}


	/**
	 * Constructor
	 */
	public Login() 
	{
		super();
		initGUI();
	}
	
	/**
	 * Passenger login function
	 * Call login function in PassengerClient
	 * 
	 * @param id
	 * @param passwd
	 */
	public void login(String id, String passwd) 
	{
		PassengerClient.getPassenger().login(id, passwd);
	}
	/**
	 * Passenger register function
	 * Call register function in PassengerClient
	 * 
	 * @param id
	 * @param passwd
	 */
	public void register(String id, String passwd) 
	{
		PassengerClient.getPassenger().register(id, passwd);
	}
	
	/**
	 * Receive error messege
	 * @param errorMSG
	 */
	/*public void getError(String errorMSG) 
	{
		// TODO error ó : unregistered ID / passwd
	}*/
	
	/**
	 * Make GUI for login.
	 * Add swing component to jDesktopPane
	 */
	private void initGUI() {
		try {

			this.setSize(317, 330);
			setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
			{
				jDesktopPane1 = new JDesktopPane();
				this.getContentPane().add(jDesktopPane1, BorderLayout.CENTER);
				jDesktopPane1.setIgnoreRepaint(true);
				jDesktopPane1.setPreferredSize(new java.awt.Dimension(309, 212));
				jDesktopPane1.setName("SnapTaxi taxi Client");
				{
					jPasswordField1 = new JPasswordField();
					jDesktopPane1.add(jPasswordField1);
					jPasswordField1.setBounds(91, 104, 171, 22);
				}
				{
					jTextField1 = new JTextField();
					jDesktopPane1.add(jTextField1);
					jTextField1.setBounds(91, 73, 171, 23);
				}
				{
					jLabel4 = new JLabel();
					jDesktopPane1.add(jLabel4);
					jLabel4.setBounds(8, 196, 296, 30);
					jLabel4.setHorizontalAlignment(SwingConstants.CENTER);
				}
				{
					jButton1 = new JButton();
					jDesktopPane1.add(jButton1);
					jButton1.setText("Login");
					jButton1.setBounds(64, 145, 84, 28);
					
					/**
					 * MouseListener for login button
					 * Check ID and password
					 * Show error message
					 */
					jButton1.addMouseListener(new MouseAdapter() {
						public void mouseClicked(MouseEvent evt) {
							String id = jTextField1.getText();
							char[] pass = jPasswordField1.getPassword();
							if ((id == null)||(pass == null))
								{
									jLabel4.setText("Please Type your ID & Password");
								}
							else if ((id.length() < 4)||(pass.length < 4))
							{
								jLabel4.setText("Password & ID Should be longer than 4");
							}
							else if ((id.length() > 12)||(pass.length > 12))
							{
								jLabel4.setText("Password & ID Should be shorter than 12");
							}
							else
							{
								jLabel4.setText("Login now... please Wait");
								String password = String.copyValueOf(pass);
								login(id,password);
							}
						}
					});

				}
				{
					jLabel1 = new JLabel();
					jDesktopPane1.add(jLabel1);
					jLabel1.setText("ID :");
					jLabel1.setBounds(44, 68, 60, 30);
				}
				{
					jLabel2 = new JLabel();
					jDesktopPane1.add(jLabel2);
					jLabel2.setText("Password :");
					jLabel2.setBounds(19, 99, 71, 30);
				}
				{
					jLabel3 = new JLabel();
					jDesktopPane1.add(jLabel3);
					jLabel3.setText("Snaptaxi Passenger Client Version 0.0.2");
					jLabel3.setBounds(30, 19, 244, 26);
				}
				{
					jButton2 = new JButton();
					jDesktopPane1.add(jButton2);
					jButton2.setText("Join");
					jButton2.setBounds(163, 145, 60, 30);
					jButton2.addMouseListener(new MouseAdapter() {
						
						/**
						 * MouseListener for join button
						 * Check ID and password
						 * Show error message
						 */
						public void mouseClicked(MouseEvent evt) {
							String id = jTextField1.getText();
							char[] pass = jPasswordField1.getPassword();
							if ((id == null)||(pass == null))
							{
								jLabel4.setText("Please Type your ID & Password to Regist");
							}
							else if ((id.length() < 4)||(pass.length < 4))
							{
								jLabel4.setText("Password & ID Should be longer than 4 to Regist");
							}
							else if ((id.length() > 12)||(pass.length > 12))
							{
								jLabel4.setText("Password & ID Should be shorter than 12 to Regist");
							}
							else{
								jLabel4.setText("Registering... please Wait");
								String password = String.copyValueOf(pass);
								register(id,password);
							}
						}
					});
				}
				
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}