
package snaptaxi.passenger;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.DatagramPacket;
import java.net.DatagramSocket;

import snaptaxi.Address;
import snaptaxi.CallMsg;
import snaptaxi.CancelCallMsg;
import snaptaxi.GPSPositionMsg;
import snaptaxi.LoginResultMsg;
import snaptaxi.Message;
import snaptaxi.SelectMsg;
import snaptaxi.SelectResultMsg;
import snaptaxi.taxi.TaxiListener;

/**
 * @author Korea Univ. SE Team #1
 * @version 1.0
 * @since 2004.11.20
 * [2004.11.20./] ~ Add source.
 * [2004.11.21.] ~ Implementation Complete. Need to modify setting of server.
 */
public class NWClient extends Thread
{
	PassengerListener listener;
	
	DatagramSocket socket=null;
    DatagramPacket packetOut=null, packetIn=null;
    byte inputB[] = new byte[1024];
    
    public NWClient() 
	{
    	this.listener = new PassengerListener(); 
		
	    // Initialize sockect and open.
    	// Because of Client, We don't have to choose the port.
	       try {
	          socket = new DatagramSocket(); 
	       }
	       catch(IOException e){
		          System.out.println("Failure: "+e);
		   }
   }
	/**
	 * @param messege
	 */
	public void sendMSG(Address address, Message msg) 
	{
		try {
			ByteArrayOutputStream outputBuf = new ByteArrayOutputStream();
	        ObjectOutputStream outputObj = new ObjectOutputStream(outputBuf);   
	        //Create ByteArrayOutputStream & ObjectOutputStream.
	        
	        outputObj.writeObject(msg);
	        //Write Message Object to ObjectOutputStream.
	        //Actually, those Object will be written in outputbuf.
	        	        
	        packetOut = new DatagramPacket(
	        		outputBuf.toByteArray(), outputBuf.size(),
					address.getIP(), address.getPort());
	        //Create Packet from information of ObjectOutputStream & Address Object.
	        socket.send(packetOut); 
	        System.out.println("Sent");
	        outputObj.close();
	        outputBuf.close();
	        //Close It.
		} catch(IOException i){// do nothing if it has IOException -_-v
			                   // cause it's BULLSHIT LIKE YOU -_-b
			
		}
	}
	
	/**
	 * @param messege
	 */
	public void run()
	{

		// Make ObjectOutputStream & ByteArrayOutputStream.
		// also, Receive Packet from network.
		// make messages to Object stream.
		// & get class name from Object stream.
		for(;;) {
			try {
				System.out.println("Flag for NWClient1");
				int len = inputB.length;
				packetIn = new DatagramPacket(inputB, len);
		        socket.receive(packetIn);
		        //Receive Packet from network.
		        System.out.println("Flag for NWClient2");
		        ByteArrayInputStream inputBuf = new ByteArrayInputStream(inputB);
		        ObjectInputStream inputObj = new ObjectInputStream(inputBuf);
		        //Make ObjectOutputStream & ByteArrayOutputStream.
		        
		        Object packet = inputObj.readObject();
		        System.out.println("Flag for NWClient2 :"+packet.getClass().getName());
		        if(packet.getClass().getName() == "snaptaxi.LoginResultMsg") {
		        	// if Class name is LoginResultMsg, Regist Object to the listener.
		        	this.listener.onLoginResult(
		        			new Address(packetIn.getAddress(), packetIn.getPort()),
							(LoginResultMsg) packet);
		        }
		        else if(packet.getClass().getName() == "snaptaxi.SelectResultMsg") {
		        	// if Class name is SelectResultMsg, Regist Object to the listener.
		        	this.listener.onSelectResult(
		        			new Address(packetIn.getAddress(), packetIn.getPort()),
							(SelectResultMsg) packet);
		        }
			} catch (IOException i){ // do nothing if it has the IOException -_-
				
			} catch (ClassNotFoundException c){// do nothing if it has ClassNotFound ALSO -_-v
											   // cause it's BULLSHIT LIKE YOU -_-b
			}
		}
	}
}
