
package snaptaxi.passenger;

import snaptaxi.*;

import java.util.HashMap;

/**
 * Handle all message.
 * Actually this is main routine.
 * 
 * @author Korea Univ. SE Team #1
 * @version 1.0
 * @since 2004.11.21
 * [2004.11.21./] ~ Class Design!
 * [2004.11.21.] ~ Class Design Edited.
 * [2004.11.29.] ~ Implement onLoginResult. still got a something to do.
 * [2004.11.29.] ~ Implement onLoginResult to throw message to PassengerClient.
 * [2004.11.29.] ~ Implement onSelectResult to throw message to PassengerClient.
 * [2004.11.30./] ~ Implement onRegistResult to throw message to PassengerClient.
 */
public class PassengerListener 
{
	// Address -> ID Map for find ID from IPAddress.
	private HashMap addressToIDMap;

	// initialize listener.
	public PassengerListener() 
	{
		this.addressToIDMap = new HashMap();
	}
	
	/**
	 * Processing login result message
	 * @param sender
	 * @param msg
	 * LOGIN_ERROR				: error
	 * LOGIN_SUCCESS			: login succession
	 * LOGIN_UNREGISTER			: unresiter customer
	 * LOGIN_INVALID_PASS		: invalid password
	 */
	public void onLoginResult(Address sender, LoginResultMsg msg) 
	{
		/**
		 * LOGIN_ERROR				: error
		 * LOGIN_SUCCESS			: login succession
		 * LOGIN_UNREGISTER			: unresiter customer
		 * LOGIN_INVALID_PASS		: invalid password
		 */
		//TODO temp
		//PassengerClient.getPassenger().loginResult(msg);
			
	}
	
	/**
	 * Process Regist result message
	 * REGIST result state flag
	 * REGIST_ERROR				: error
	 * REGIST_SUCCESS			: regist succession
	 * REGIST_REGISTERED		: already registered customer
	 * REGIST_DBERROR			: database error.
	 */
	public void onRegistResult(Address sender, RegistResultMsg msg)
	{
		/**
		 * REGIST result state flag
		 * REGIST_ERROR				: error
		 * REGIST_SUCCESS			: regist succession
		 * REGIST_REGISTERED		: already registered customer
		 * REGIST_DBERROR			: database error.
		 */
		//TODO
		//PassengerClient.getPassenger().registResult(msg);
	}
	
	/**
	 * Call selectResult function in PasssengerClient
	 * @param sender
	 * @param msg
	 * RESULT_ERROR : error
	 * RESULT_SELECT : select success
	 * RESULT_ALREADY_SELECT : passenger already selected
	 * RESULT_UNSELECT : unselect passenger.
	 */
	public void onSelectResult(Address sender, SelectResultMsg msg) 
	{
		PassengerClient.getPassenger().selectResult(msg);
	}
	
	/**
	 * @param sender
	 * @param msg
	 */
	/*
	public void onCancelTaxiCall(Address sender, SelectResultMsg msg) 
	{
		
	}
	*/
}