//Source file: C:\\temp\\snaptaxi.client\\TaxiClient.java

package snaptaxi.taxi;

import java.net.InetAddress;
import java.net.UnknownHostException;

import snaptaxi.*;
import java.util.*; 


/**
* This code was generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* *************************************
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED
* for this machine, so Jigloo or this code cannot be used legally
* for any corporate or commercial purpose.
* *************************************
*/
/**
 * Managing whole taxi client service!
 * 
 * @author SE Team#1
 * @version 1.0
 * @since [04.11.19 /ȫ] ~ Class Design
 * @since [04.11.20 /ȫ] ~ Add Coment
 * @since [04.11.20 /ȫ] ~ Add sendMessage
 * @since [04.11.20 /ȫ] ~ Implement
 * @since [04.11.20 /ȫ] ~ Roll Back~!
 * @since [04.11.20 /ȫ] ~ join method add!
 * @since [04.11.28 /ȫ] ~ Modify send message!
 * @since [04.11.29 /ȫ] ~ Modify join method!
 * @since [04.11.29 /ȫ] ~ Finding NullPointException!
 * @since [04.11.29 /ȫ] ~ Modify server address
 * @since [04.11.30 /ȫ] ~ Implement loginResult, registResult
 * @since [04.12.03 /ȫ] ~ Add clickPassenger
 */
public class TaxiClient 
{
	private String id;
	private String passengerID;
	private int state;
	private NetClient server;
	//TODO  ּҸ ش.
	private Address serverAddress;
	private static LoginForm loginForm;
	private static ServiceForm serviceForm;
	private HashMap customer;
	
	// TaxiClient.singleton : singleton object to contect from other files.
	private static TaxiClient singleton = null;
	
	private TaxiClient() 
	{
		id = null;
		passengerID = null;
		customer = new HashMap();
		state = 0; //TODO ý ¸ մ   ִ · ʱȭ
		server = new NetClient();

		try {
			InetAddress temp = InetAddress.getByName("127.0.0.1");
			serverAddress = new Address(temp,3000);
		}catch(UnknownHostException e) {
			System.out.println("Host Connection Failed");
			serverAddress = new Address();
			//TODO need implements to set it up in 127.0.0.1 or exit call.
		}
	}
	
	//TODO ׽Ʈ  ӽ÷ ۼ main
	public static void main(String[] args) {
		loginForm = new LoginForm();
		loginForm.setVisible(true);
		serviceForm = new ServiceForm();	
	}

	/**
	 * Access singleton!
	 * 
	 * @return TaxiClient.singleton
	 */
	public static TaxiClient getTaxi() 
	{
	    if (null == TaxiClient.singleton) {
	        TaxiClient.singleton = new TaxiClient();
	    }
		return TaxiClient.singleton;
	}

	/**
	 * Call NetClient's login method!
	 * 
	 * @param id	: Taxi's id
	 * @param pass	: Taxi's password
	 */
	public void login(String id, String pass) 
	{
		this.id = id;
		//sendMessage(serverAddress, new LoginMsg(id, pass));
		
		loginForm.setVisible(false);
		loginForm.init();
		serviceForm.setVisible(true);
		server.start();
	}
	
	/**
	 * Receive result of login proceess from NetClient(Server)!
	 * 
	 */
	public void loginResult(LoginResultMsg msg) 
	{	
		// Login Success
		if(msg.isSuccess())
		{
			loginForm.setVisible(false);
			loginForm.init();
			serviceForm.setVisible(true);
			
		}
		// Login Error
		else
		{
			this.id = null;
			loginForm.loginResult(msg);
		}
	}
	
	/**
	 * Regist Taxi's information!
	 * 
	 * @param id	: Taxi's id
	 * @param pass	: Taxi's password
	 */
	public void join(String id, String password) 
	{
		this.id = id;
		//sendMessage(serverAddress, new RegistMsg(id, password, (byte)2));

		loginForm.setVisible(false);
		loginForm.init();
		serviceForm.setVisible(true);
		server.start();
	}
	
	/**
	 * Result of Regist
	 * 
	 * @param id	: Taxi's id
	 * @param pass	: Taxi's password
	 */
	public void registResult(RegistResultMsg msg) 
	{
		/**
		 * REGIST result state flag
		 * REGIST_ERROR				: error
		 * REGIST_SUCCESS			: regist succession
		 * REGIST_REGISTERED		: already registered customer
		 * REGIST_DBERROR			: database error.
		 */
		// register success
		if(msg.isSuccess())
		{
			loginForm.setVisible(false);
			loginForm.init();
			serviceForm.setVisible(true);
			
		}
		// register error
		else
		{
			this.id = null;
			loginForm.registResult(msg);
		}
	}

	/**
	 * Call NetClient's logout method!
	 * 
	 * @param id	: Taxi's id
	 */
	public void logout() 
	{
		LogoutMsg TaxiLogoutMsg = new LogoutMsg(id);
		serviceForm.setVisible(false);
		//sendMessage(serverAddress, TaxiLogoutMsg);		
	}
	
	/**
	 * UnRegist Taxi's information!
	 * Call NetClient's unregist method!
	 * 
	 * @param id	: Taxi's id
	 * @param pass	: Taxi's password
	 */
	public void unRegist() 
	{
		UnregistMsg TaxiUnregistMsg = new UnregistMsg(id);
		serviceForm.setVisible(false);
		//sendMessage(serverAddress, TaxiUnregistMsg);
		
	}
	
	/**
	 * select passenger!
	 * Send selectMsg to server!
	 * 
	 * @param id	: Taxi's id
	 * @param pass	: Taxi's password
	 */
	public void select(String passengerID, int port) 
	{
		this.passengerID = passengerID; 
		SelectResultMsg TaxiSelectMsg = new SelectResultMsg(1, passengerID);
		sendMessage(serverAddress, TaxiSelectMsg, port);
				
	}
	
	/**
	 * The result of selection!
	 * Recieve message from server!
	 * 
	 */
	public void selectResult() 
	{
		/**
		 * Select passenger flag.
		 * RESULT_ERROR : error
		 * RESULT_SELECT_SUCCESS : select success
		 * RESULT_SELECT_FAIL : select fail.
		 * RESULT_SELECTED : passenger selected by other taxi.
		 * RESULT_UNSELECT : passenger is unselected.
		 */

		//Success 	: select success
		this.state = 0; //TODO Ʈ ߿ 
		//Fail 		: select fail
		//Selected	: selected by other taxi
	}
	
	/**
	 * Cancle Selection!
	 * Send CancelMsg to server!
	 * 
	 */
	public void unSelect(String passengerID, int port) 
	{
		this.passengerID = null;
		SelectResultMsg unSelectMsg = new SelectResultMsg(2, passengerID);
		sendMessage(serverAddress, unSelectMsg, port);
		//sendMessage(serverAddress, unSelectMsg);
	}
	
	/**
	 * Called by passenger!
	 * Add Passenger's information to passenger list.
	 * And add passenger's location to map.
	 * 
	 * @param CallMsg
	 */
	public void call(CallMsg msg, int port) 
	{
		//TODO 	CancleCall ޽ ޾ 
		//		TaxiClient ޸𸮿 ִ´
		//		posX, posY  ó
		//		ServiceForm List Ѹ
		//		ServiceForm Map Ѹ
		
		serviceForm.call(msg.getPassengerID(),msg.getPosX(), msg.getPosY(), port);
	}

	/**
	 * Cancle Selection!
	 * Send CancelMsg to server!
	 * 
	 */
	public void cancelCall(CancelCallMsg msg) 
	{
		//TODO 	CancleCall ޽ ޾ 
		//  մ  :
		//		޽ 
		//Default :
		//		ServiceForm List 
		//		ServiceForm Map 
		//		TaxiClient ޸𸮿 
		System.out.println("CANCELCALL!!!!\n"+msg.getPassengerID());
		serviceForm.cancelCall(msg.getPassengerID());
	}

	/**
	 * Change state of taxi!
	 * Send changestate message to server!
	 * 
	 */
	public void changeState(int state) 
	{
		this.state = state;
		ChangeStateMsg TaxiChangeStateMsg = new ChangeStateMsg(id, state);
		//sendMessage(serverAddress, TaxiChangeStateMsg, port);
	}
	
	/**
	 * Recieve location information from GPS!
	 * Then send information to server!
	 * 
	 */
	public void GPSPositionMsg() 
	{
		int postX =0; 
		int postY =0;
		GPSPositionMsg TaxiGPSPositoinMsg = new GPSPositionMsg(id, postX, postY);	
		//sendMessage(Address address, TaxiGPSPositoinMsg);
	}

	/**
	 * Send message to client.
	 */
	public void sendMessage(Address address, Message msg, int port)
	{
		this.server.sendMessage(address, msg, port);
	}
	
	public void clickPassenger(String id)
	{
		//CustomerState tempPassenger = new CustomerState();
		//tempPassenger = (CustomerState)customer.get(id);
		serviceForm.showDetailInfo(id);
	}
}
